/*************************************************************************
* smfunction.h - some usefull function for surface shaders and ligth with
*               color output __nonShadow. For produce shadow pass rendring.
*
* Author: Konstantin Kharitonov (aqua@sm.bmstu.ru)
*
* $Rev.: 1.1  $Date: 2000/01/13
**************************************************************************/

#ifndef SMFUNCTION_H
#define SMFUNCTION_H 1

color diffuse (normal Nn; float useShadowPass)
{
  color C = 0;
  extern point P;
  illuminance (P, Nn, PI/2) {
    extern vector L; extern color Cl;
    float nondiff;
    color nonshadow=0;
    if (0==lightsource ("__nonShadow", nonshadow))
      nonshadow=0;
    if (0==lightsource ("__nondiffuse", nondiff))
      nondiff = 0;
    if ((useShadowPass == 1) && (0 != lightsource ("__nonShadow", nonshadow))) {
       C +=nonshadow *(1-nondiff)* (Nn.normalize(L));
    }
    else {
       C += Cl * (1-nondiff) * (Nn.normalize(L));
    }
  }
  return C;
}

color diffuse (normal Nn)
{
  color C = 0;
  extern point P;
  illuminance (P, Nn, PI/2) {
    extern vector L; extern color Cl;
	float nondiff;
	if (0==lightsource ("__nondiffuse", nondiff))
    nondiff = 0;
    C += Cl * (1-nondiff) * (Nn.normalize(L));

  }
  return C;
}


color specular (normal Nn; vector V; float roughness; float useShadowPass)
{
  color C=0;
  extern point P;
  illuminance (P, Nn, PI/2) {
    extern vector L;  extern color Cl;
    float nonspec=0;
    color nonshadow=0;
    if (0==lightsource ("__nonShadow", nonshadow))
      nonshadow=0;
    if (0==lightsource ("__nonspecular",nonspec ))
      nonspec = 0;
    if ((useShadowPass == 1) && (0 != lightsource ("__nonShadow", nonshadow))) {
      C += nonshadow*(1-nonspec)*specularbrdf(normalize(L),normalize(Nn),normalize(V), roughness);;
    }
    else {
      C += Cl*(1-nonspec)*specularbrdf (normalize(L),normalize(Nn),normalize(V), roughness);
   }
  }
  return C;
}

color specular (normal Nn; vector V; float roughness)
{
  color C=0;
  extern point P;
  illuminance (P, Nn, PI/2) {
    extern vector L;  extern color Cl;
    float nonspec=0;
	if (0==lightsource ("__nonspecular",nonspec ))
      nonspec = 0;
    C += Cl*(1-nonspec)*specularbrdf (normalize(L),normalize(Nn),normalize(V), roughness);
  }
  return C;
}

#endif /* SMFUNCTION_H */
