/*************************************************************************
* smfunction.h - some usefull function for surface shaders and ligth with
*               color output __nonShadow. For produce shadow pass rendring.
*
* Author: Konstantin Kharitonov (aqua@sm.bmstu.ru)
*
* $Rev.: 1.0  $Date: 2000/01/10
**************************************************************************/

#ifndef SMFUNCTION_H
#define SMFUNCTION_H 1

color smdiffuse (normal Nn; vector V; float roughness; float useShadowPass)
{
  color C = 0;
  extern point P;
  illuminance (P, N, PI/2) {
    extern vector L; extern color Cl;
    color nonshadow = 0;
    float nondiff = 0;
    lightsource ("__nondiffuse", nondiff);
    if (nondiff < 1) {
      if (useShadowPass == 1) && (0 != lightsource ("__nonShadow", nonshadow)) {
        C += nonshadow * (1-nondiff) * (Nn.normalize(L));
      }
      else {
        C += Cl * (1-nondiff) * (Nn.normalize(L));
      }
    }
  }
  return C;
}

color smspecular (normal Nn; vector V; float roughness; float useShadowPass)
{
  color C = 0;
  extern point P;
  illuminance (P, N, PI/2) {
    extern vector L;  extern color Cl;
    color nonshadow = 0;
    float nonspec = 0;
    lightsource ("__nonspecular", nonspec);
    if (nonspec < 1) {
      vector H = normalize(normalize(L)+V);
      if (useShadowPass == 1) && (0 != lightsource ("__nonShadow", nonshadow)) {
        C += nonshadow * (1-nonspec) * pow(max(0,N.H), 1/roughness);
      }
      else {
        C += Cl * (1-nonspec) * pow(max(0,N.H), 1/roughness);
      }
    }
  }
  return C;
}

#endif /* SMFUNCTION_H */
